Description

I installed German as default language and 3 further languages:
en L=1
tr L=2
ru L=3

Unfortunately I am not able to relink language ru (L=3) back to English (L=1). The program will always switch to the default language
(German).

My configuration:

###

config {    # Default-Sprache
    linkVars = L
    uniqueLinkVars = 1
    sys_language_uid = 0
    language = de
    locale_all = de_DE
    htmlTag_langKey = de-DE
    sys_language_mode = content_fallback
    sys_language_overlay = 1
}
page.config.language = de
page.config.locale_all = de_DE.UTF-8

[globalVar = GP:L = 1]
config {
    sys_language_uid = 1
    sys_language_mode = content_fallback ; 0
    language = en
    locale_all = en_US
    htmlTag_langKey = en-US
}
page.config.language = en
page.config.locale_all = en_EN
[global]

[globalVar = GP:L = 2]
config {
    sys_language_uid = 2
    sys_language_mode = content_fallback ; 0,1
    language = tr
    locale_all = tr_TR
    htmlTag_langKey = tr-TR
}
page.config.language = tr
[global]

[globalVar = GP:L = 3]
config {
    sys_language_uid = 3
    sys_language_mode = "content_fallback ; 1,0" 
    language = ru
    locale_all = ru_RU
    htmlTag_langKey = ru-RU
}
page.config.language = ru
[global]

###

Bernd Warken

(issue imported from #M8986)

Related issues:
related to Core - Bug # 17354: fallback for menus. "content_fallback;1,0" has... Under Review 2007-07-22
related to Core - Bug # 19718: Typoscript:  CONTENT | slide: multilanguage no... Accepted 2008-12-18
related to Core - Bug # 48673: Changed language overlay behaviour in TYPO3 6.* Accepted 2013-05-30

History
#1 - 2009-02-25 18:46 - Christian Kuhn

Hi Bernd,

I read your issue description twice, but I just do not understand your problem. Is this still valid for you? Could you please explain in a bit more detail
what you try to achieve? What do you mean with "relink language ru (L=3) back to English (L=1)"? Which link should be created and when? In a
content element or in a language selector?

#2 - 2009-02-26 12:19 - Bernd Warken

This issue is still valid, even with TYPO3 4.1.10 and 4.2.6.  The term "relink" refers to the fact that TYPO3 replaces untranslated parts by the
corresponding part in another language. This is usually the default language (German for me), but for Russian it should print the English text.

As an example, see http://www.schulungsraum-muenchen.de. There, untranslated Turkish prints correctly the German text because of
config.sys_language_mode = content_fallback ; 1,0

But Russian had the TypoScript code
config.sys_language_mode = content_fallback ; 0,1
So it should print the text for L=1 (English for me), but it does not and prints the German text instead.
So config.sys_language_mode does not work according to the documentation.

#3 - 2009-02-26 12:41 - Steffen Kamper

sry, i don't see any russian or turkish translation there.

config.sys_language_mode = content_fallback ; 0,1

doesn't make sense, as it always fall back to 0 which is german in your case.

also using "" is wrong.

#4 - 2009-02-26 16:48 - Bernd Warken

Exactly, the Russian and Turkish should be redirected as untranslated, so there is no translation.

I now tried 
config.sys_language_mode = content_fallback ; 1
without quotes for the Russian, so it should redirect to English; but it still redirects to the German default. No idea.

#5 - 2009-04-06 12:41 - Michael Stucki

The problem is that config.sys_language_mode only affects the page record. There is no content-fallback if the current page is translated, but not all
records on it.

I have written a patch that implements this for TYPO3 4.2.6. Please try it out and let me know if that helps.

- michael

#6 - 2009-04-06 14:46 - Michael Stucki

Attached is a patch that fixes the problem at least partly:

Preconditions:
- config.sys_language_overlay is 1
- config.sys_language_mode = content_fallback; <uid-list>

In such a case, a page that is translated will always select the default language unless the record is localized. However, if the record is localized for a
language which is different than the selected one but matches the content-fallback list, this would currently have no effect.

The patch solves this by walking through the content-fallback list.

#7 - 2009-04-23 16:02 - Michael Stucki

Added new patch which implements the same for t3lib_pageSelect::getPageOverlay(). This will affect menus etc.

#8 - 2009-07-14 12:01 - Jens Schmietendorf
I´ve tried out the first patch, it works great.

#9 - 2009-07-23 17:56 - Johannes Schlatow

I tried the second patch. It's just great.

#10 - 2010-05-27 23:17 - Gregor Schreier

i've implement the second patch in TYPO3 - 4.3.3, works !
- even if an alternative Pagetranslation exist with no Content on it

Why is this not in the Core ? This is an must have for mulitlanguage-sites.

I use this with patch from 6009 - ( T3X_danp_languagefallback_patch-0_0_0-z-200708151515.t3x )

#11 - 2010-05-27 23:23 - Chris topher

Hi guys,

the point is that nobody has sent this patch to Core List.

To get this fix in the next releases, one of you has to post it to the TYPO3-Core-list.
Check out http://typo3.org/teams/core/core-mailinglist-rules

#12 - 2010-05-28 10:23 - Steffen Ritter

Send to core list...

#13 - 2010-07-02 15:48 - Gregor Schreier

upload new patch for TYPO3 4.4.0

#14 - 2010-07-02 15:52 - Gregor Schreier

patch is also send to core list

#15 - 2010-11-26 16:06 - Martin R. Krause

The 8986_v3 Patch has a drawback:

The option hide page if no translation exists is ignored, if the language in question does not fall back to the default language directly. In this (not so
rare) case the page will be show, no matter if a translation exists an the tranlated page is set hidden or no translation has been set up (in which case
content fallback will work).

So the patch has to be refined to respect the l18n_cfg field from the pages table.
Any ideas, how?

#16 - 2011-03-10 12:11 - Dmitry Dulepov

I do not think this will work correctly because tslib_fe calls the patched function with different language ids from the "content_fallback":

$fallBackOrder = t3lib_div::intExplode(',', $sys_language_content);
foreach($fallBackOrder as $orderValue)    {
    if (!strcmp($orderValue,'0') || count($this->sys_page->getPageOverlay($this->id, $orderValue)))    {
        $this->sys_language_content = $orderValue;    // Setting content uid (but leaving the sys_language_uid)
        break;
    }
}

Instead of returning the result for that language, your patched version return the result for some other language. TSFE will assign a wrong language id
(not the one you found but the one it supplied to the patched function).

What you should do to ensure that languages work:
- content_fallback is set correctly, no changes here
- set config.sys_language_mode to hideIfNotTranslated (or whatever it is, see in TSRef) or to 0 (what best suits your needs)
- [!!!] make sure that you do NOT have an "alternative language record" for the language where you do not have any content. An existing alternative
page language makes the page translated and it shows you the translated page content, which is empty in your case. Content fallback happens only
and only if you have no alt page language (=page is not translated). This is how it should work. Even TSRef says so: "The system will always operate
with the selected language even if the page is not translated with a page overlay record. This will keep menus etc. translated. However, the content on
the page can still fall back to another language, defined by the value of this keyword" 
- [!!!] make sure that hidePagesIfNotTranslatedByDefault=0 in the install tool. If it is 1, you will get a 404 error when you remove the alt page language
record.

So there is no bug there. And the patch is wrong, sorry.

#17 - 2011-03-10 12:12 - Dmitry Dulepov

I wrote all of the above because we just had the same issue and solved it only by a proper combination of settings. In our case the Install tool setting
was causing problems.

#18 - 2012-09-08 22:35 - Gerrit Code Review
- Status changed from Accepted to Under Review

Patch set 1 for branch master has been pushed to the review server.
It is available at http://review.typo3.org/14464

#19 - 2012-09-08 22:39 - Gerrit Code Review

Patch set 2 for branch master has been pushed to the review server.
It is available at http://review.typo3.org/14464
#20 - 2012-09-08 22:41 - Gerrit Code Review

Patch set 3 for branch master has been pushed to the review server.
It is available at http://review.typo3.org/14464

#21 - 2012-09-09 00:16 - Gerrit Code Review

Patch set 4 for branch master has been pushed to the review server.
It is available at http://review.typo3.org/14464

#22 - 2012-09-09 00:24 - Ingo Pfennigstorf

The current patch has been testet with current master and "normal" content rendering, patchset 3 also with TYPO3 4.5 and TemplaVoila.

#23 - 2012-09-09 01:47 - Markus Klein

Please look at the more general solution in #17354.

#24 - 2012-09-09 02:16 - Stefan Neufeind

#17354 takes a much more generic approach. Please see my comment in that review (https://review.typo3.org/14464).
As such it tries to change more and would imho clearly be a [FEATURE] (as it is already mentioned in the review-request). Since feature-freeze for 6.0
is over it also can't even go into 6.0. And face the facts: We have broken content_fallback in the LTS-version (from 4.5 all through to 6.0).

So imho #17354 would be nice to have and is under discussion as a new "feature" (in what form it might be accepted). But this here for the moment is
a bugfix (!).

#25 - 2012-09-11 08:55 - Ingo Pfennigstorf

#34670 (duplicate) shows some additional information

#26 - 2012-09-25 01:47 - Gerrit Code Review

Patch set 5 for branch master has been pushed to the review server.
It is available at http://review.typo3.org/14464

#27 - 2013-01-08 09:34 - Camelia M

I have this problem too using typo3 6.0 and templavoila 1.8.0. Is there a working patch for typo3 6.0?

#28 - 2013-02-15 23:32 - Mike Gebhard

I´ve just patched my 6.0.2 installation and it works fine. I used the Patch-Set 5 which is currently under review.
#29 - 2013-02-18 08:13 - Camelia M

Mike Gebhard wrote:

I´ve just patched my 6.0.2 installation and it works fine. I used the Patch-Set 5 which is currently under review.

for me works ok too

#30 - 2013-05-06 22:31 - Gerrit Code Review

Patch set 6 for branch master has been pushed to the review server.
It is available at https://review.typo3.org/14464

#31 - 2015-01-23 13:41 - Gerrit Code Review

Patch set 7 for branch master of project Packages/TYPO3.CMS has been pushed to the review server.
It is available at http://review.typo3.org/14464

Files
bug_8986.diff 2.4 kB 2009-04-06 Administrator Admin
bug_8986_v2.diff 4.8 kB 2009-04-23 Administrator Admin
patch_8986_v3.diff 4.8 kB 2010-07-02 Administrator Admin
